static NewBranch  _NewBranch;

public class NewBranch : Object
{
    public Gtk.Dialog el;
    private NewBranch  _this;

    public static NewBranch singleton()
    {
        if (_NewBranch == null) {
            _NewBranch= new NewBranch();
        }
        return _NewBranch;
    }
    public Xcls_projectsel projectsel;
    public Xcls_prcellrenderer prcellrenderer;
    public Xcls_prmodel prmodel;
    public Xcls_ticketsel ticketsel;
    public Xcls_dbcellrenderer dbcellrenderer;
    public Xcls_dbmodel dbmodel;
    public Xcls_name name;
    public Xcls_createbtn createbtn;
    public Xcls_btn_not_me btn_not_me;
    public Xcls_btn_closed btn_closed;
    public Xcls_scrolled_window scrolled_window;
    public Xcls_view view;
    public Xcls_label_select_ticket label_select_ticket;
    public Xcls_label_create_ticket label_create_ticket;
    public Xcls_label_quick_commit label_quick_commit;

        // my vars (def)
    public GitRepo? repo;
    public bool running;
    public Gee.ArrayList<GitMonitorQueue> queue;

    // ctor
    public NewBranch()
    {
        _this = this;
        this.el = new Gtk.Dialog();

        // my vars (dec)
        this.repo = null;
        this.running = false;
        this.queue = null;

        // set gobject values
        this.el.title = "Create a working branch ";
        this.el.default_height = 500;
        this.el.default_width = 500;
        this.el.deletable = true;
        this.el.modal = true;
        var child_0 = new Xcls_Box2( _this );
        child_0.ref();
        this.el.get_content_area().add (  child_0.el  );
        var child_1 = new Xcls_Notebook22( _this );
        child_1.ref();
        this.el.add (  child_1.el  );
        var child_2 = new Xcls_Box26( _this );
        child_2.ref();
        this.el.append_page (  child_2.el , _this.label_select_ticket.el );

        //listeners
        this.el.delete_event.connect( (self, event) => {
            this.el.hide();
            return true; 
            //test  
        });
        this.el.response.connect( (self, response_id) =>  { 
          
        	GLib.debug("got %d", (int) response_id);
        	
        	 
        	
        	 
        	// have they selected a ticket..
        	// make that the current active ticket?
        	// we really need to store locally what ticket is being worked on..
        	// in theory we could be working on multiple project and not merging..
        	// -- each repo would have their active ticket (only one per repo)
        	// -- so we could just store that in there
        	// -- initial load can check the contents of the ticket files on first scan.
        
        	 
        	if (response_id < 1) {
        	    _this.el.hide();	
        	    this.running = false; 
        	 	return;
        	}
        	
        	var ticket_id = _this.ticketsel.selectedTicketId();
        	
            if (this.repo != null) {
            	var bn = _this.name.el.get_text();
        
        		var res = this.repo.setActiveTicket(			
        			 RooTicket.singleton().getById(ticket_id != "" ? ticket_id : "-1"), bn
        		 );
        		 if (res) {
        		 	// start the monitoring..
        		 	 GitMonitor.gitmonitor.start();
        		 	 
        		 }
            }
             
        
            this.running = false; 
        
        	this.el.hide();
        	 
        	 
        
        	 
        });
    }

    // user defined functions
    public   void show ( GitRepo repo, Gee.ArrayList<GitMonitorQueue> queue, string tid = "" ) 
    {
         // this.el.set_gravity(Gdk.Gravity.NORTH);
        if (this.running) { // should not happen!!
        	GLib.error("new branch show called, when already being displayed?");
    	}
    	this.queue = queue;
    	
    	this.running  = true;
    	GitMonitor.gitmonitor.stop();
    	
        this.repo = repo;
        
         
        
    	this.el.move((Gdk.Screen.width() / 2)- 250 ,0);
    	this.el.set_default_size( 500,200); // not sure why it grows..
        GLib.debug("Loading tickets"); 
         
    
        this.el.show_all();
        this.el.set_keep_above(true);
       
        
        var curproj = RooProject.getProjectByRepo(this.repo);
         _this.prmodel.loadProjects(curproj == null ? "" : curproj.id);
        
     	_this.dbmodel.loadTickets(curproj == null ? "": curproj.id, tid);
     	_this.createbtn.updateState();
     	
    	_this.ticketsel.el.get_child().get_style_context().remove_class("warning");
     	if (tid != "") { 
    	 	var name = RooTicket.singleton().usernameLocal();
     		var ticket = RooTicket.singleton().getById(tid);
    		_this.name.el.set_text("wip_%s_T%s_%s".printf(name,ticket.id, ticket.summaryToBranchName()));
    	} else {
    		_this.ticketsel.el.get_child().get_style_context().add_class("warning");
    	}
        _this.view.loadTicket(tid);
     	this.el.run();
    
    }
    public class Xcls_Box2 : Object
    {
        public Gtk.Box el;
        private NewBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_Box2(NewBranch _owner )
        {
            _this = _owner;
            this.el = new Gtk.Box( Gtk.Orientation.VERTICAL, 0 );

            // my vars (dec)

            // set gobject values
            var child_0 = new Xcls_Table3( _this );
            child_0.ref();
            this.el.pack_start (  child_0.el , false,false,0 );
            var child_1 = new Xcls_scrolled_window( _this );
            child_1.ref();
            this.el.add (  child_1.el  );
        }

        // user defined functions
    }
    public class Xcls_Table3 : Object
    {
        public Gtk.Table el;
        private NewBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_Table3(NewBranch _owner )
        {
            _this = _owner;
            this.el = new Gtk.Table( 5, 5, true );

            // my vars (dec)

            // set gobject values
            this.el.expand = false;
            this.el.margin = 2;
            this.el.column_spacing = 4;
            this.el.vexpand = false;
            var child_0 = new Xcls_Label4( _this );
            child_0.ref();
            this.el.attach_defaults (  child_0.el , 0,1,0,1 );
            var child_1 = new Xcls_Label5( _this );
            child_1.ref();
            this.el.attach_defaults (  child_1.el , 1,2,0,1 );
            var child_2 = new Xcls_projectsel( _this );
            child_2.ref();
            this.el.attach_defaults (  child_2.el , 0,1,1,2 );
            var child_3 = new Xcls_ticketsel( _this );
            child_3.ref();
            this.el.attach_defaults (  child_3.el , 1,4,1,2 );
            var child_4 = new Xcls_Button12( _this );
            child_4.ref();
            this.el.attach_defaults (  child_4.el , 4,5,1,2 );
            var child_5 = new Xcls_Label13( _this );
            child_5.ref();
            this.el.attach_defaults (  child_5.el , 0,1,3,4 );
            var child_6 = new Xcls_name( _this );
            child_6.ref();
            this.el.attach_defaults (  child_6.el , 0,4,4,5 );
            var child_7 = new Xcls_createbtn( _this );
            child_7.ref();
            this.el.attach_defaults (  child_7.el , 4,5,4,5 );
            var child_8 = new Xcls_Box16( _this );
            child_8.ref();
            this.el.attach_defaults (  child_8.el , 0,5,2,3 );
        }

        // user defined functions
    }
    public class Xcls_Label4 : Object
    {
        public Gtk.Label el;
        private NewBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_Label4(NewBranch _owner )
        {
            _this = _owner;
            this.el = new Gtk.Label( "Project" );

            // my vars (dec)

            // set gobject values
            this.el.halign = Gtk.Align.START;
            this.el.justify = Gtk.Justification.RIGHT;
            this.el.visible = true;
        }

        // user defined functions
    }

    public class Xcls_Label5 : Object
    {
        public Gtk.Label el;
        private NewBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_Label5(NewBranch _owner )
        {
            _this = _owner;
            this.el = new Gtk.Label( "Ticket" );

            // my vars (dec)

            // set gobject values
            this.el.halign = Gtk.Align.START;
            this.el.visible = true;
        }

        // user defined functions
    }

    public class Xcls_projectsel : Object
    {
        public Gtk.ComboBox el;
        private NewBranch  _this;


            // my vars (def)
        public bool loading;

        // ctor
        public Xcls_projectsel(NewBranch _owner )
        {
            _this = _owner;
            _this.projectsel = this;
            this.el = new Gtk.ComboBox.with_entry();

            // my vars (dec)
            this.loading = false;

            // set gobject values
            var child_0 = new Xcls_prcellrenderer( _this );
            child_0.ref();
            this.el.pack_start (  child_0.el , true );
            var child_1 = new Xcls_prmodel( _this );
            child_1.ref();
            this.el.set_model (  child_1.el  );

            // init method

            this.el.set_entry_text_column(1);

            //listeners
            this.el.changed.connect( () => {
            	if (this.loading) {
            		return;
            	}
            	var project_id = this.selectedProjectId();
            	_this.dbmodel.loadTickets(project_id);
            	
            	
            	/*if (this.loading) {
            		return;
            	}
            	var ticket_id = this.selectedTicketId();
            	
            	var name = RooTicket.singleton().usernameLocal();
            	
            	if (ticket_id == "" || ticket_id == null) {
            	
            		var dt = new  DateTime.now_local();
            		_this.name.el.set_text("wip_%s_%s".printf(name,dt.format("%Y_%b_%d")));
            		return;
            	}
            	
            	
            	var ticket = RooTicket.singleton().getById(ticket_id);
               
            	_this.name.el.set_text("wip_%s_T%s_%s".printf(name,ticket.id, ticket.summaryToBranchName()));
            	
            	//GLib.debug (//"Selection: %s, %s\n", (string) val1, (string) val2);
            	*/
            });
        }

        // user defined functions
        public string selectedProjectId () {
        	Gtk.TreeIter iter;
        	Value val1;
         
         
        	this.el.get_active_iter (out iter);
        	_this.prmodel.el.get_value (iter, 0, out val1);
         
        
        	return  (string) val1;
        	
        	
        	
        	
        }
    }
    public class Xcls_prcellrenderer : Object
    {
        public Gtk.CellRendererText el;
        private NewBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_prcellrenderer(NewBranch _owner )
        {
            _this = _owner;
            _this.prcellrenderer = this;
            this.el = new Gtk.CellRendererText();

            // my vars (dec)

            // set gobject values
        }

        // user defined functions
    }

    public class Xcls_prmodel : Object
    {
        public Gtk.ListStore el;
        private NewBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_prmodel(NewBranch _owner )
        {
            _this = _owner;
            _this.prmodel = this;
            this.el = new Gtk.ListStore( 2, typeof(string),typeof(string) );

            // my vars (dec)

            // set gobject values
        }

        // user defined functions
        public void loadProjects (string id) {
        
        
            
            _this.projectsel.loading = true;
        
            this.el.clear();                                    
            Gtk.TreeIter iter;
            var el = this.el;
            
            el.append(out iter);
        
            
            el.set_value(iter, 0, "");
            el.set_value(iter, 1, "-- select a project --");
            if (id == "") {
        	    _this.projectsel.el.set_active_iter(iter);
            }
          
            foreach(var project in RooProject.projects()) {
            
                el.append(out iter);
                
                el.set_value(iter, 0, project.id);
                el.set_value(iter, 1,  project.name );
                if (id == project.id) {
        	 	   _this.projectsel.el.set_active_iter(iter);
        	    }   
                
            }
            
            _this.projectsel.loading = false;
             //this.el.set_sort_column_id(0, Gtk.SortType.ASCENDING);          
                                             
        }
    }


    public class Xcls_ticketsel : Object
    {
        public Gtk.ComboBox el;
        private NewBranch  _this;


            // my vars (def)
        public bool loading;

        // ctor
        public Xcls_ticketsel(NewBranch _owner )
        {
            _this = _owner;
            _this.ticketsel = this;
            this.el = new Gtk.ComboBox.with_entry();

            // my vars (dec)
            this.loading = false;

            // set gobject values
            var child_0 = new Xcls_dbcellrenderer( _this );
            child_0.ref();
            this.el.pack_start (  child_0.el , true );
            var child_1 = new Xcls_dbmodel( _this );
            child_1.ref();
            this.el.set_model (  child_1.el  );

            // init method

            //this.el.add_attribute(_this.dbcellrenderer.el , "markup", 1 );
            this.el.set_entry_text_column(1);
            this.el.get_child().set_sensitive(false);

            //listeners
            this.el.changed.connect( () => {
            	if (this.loading) {
            		return;
            	}
            	var ticket_id = this.selectedTicketId();
            	
            	var name = RooTicket.singleton().usernameLocal();
            	
            	this.el.get_child().get_style_context().remove_class("warning");
            	if (ticket_id == "" || ticket_id == null) {
            	
            		var dt = new  DateTime.now_local();
            		_this.name.el.set_text("wip_%s_%s".printf(name,dt.format("%Y_%b_%d")));
            		_this.view.loadTicket("");		
            		
            		this.el.get_child().get_style_context().add_class("warning");
            		_this.createbtn.updateState();
            		return;
            	}
            	
            	
            	var ticket = RooTicket.singleton().getById(ticket_id);
               
            	_this.name.el.set_text("wip_%s_T%s_%s".printf(name,ticket.id, ticket.summaryToBranchName()));
            	_this.scrolled_window.el.show();
            	 
            	_this.view.loadTicket(ticket.id);
            	_this.createbtn.updateState();
            	
            	//GLib.debug (//"Selection: %s, %s\n", (string) val1, (string) val2);
            });
        }

        // user defined functions
        public string selectedTicketId () {
        Gtk.TreeIter iter;
        	Value val1;
         
         
        	this.el.get_active_iter (out iter);
        	_this.dbmodel.el.get_value (iter, 0, out val1);
         
        
        	return  (string) val1;
        	
        	
        	
        	
        }
    }
    public class Xcls_dbcellrenderer : Object
    {
        public Gtk.CellRendererText el;
        private NewBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_dbcellrenderer(NewBranch _owner )
        {
            _this = _owner;
            _this.dbcellrenderer = this;
            this.el = new Gtk.CellRendererText();

            // my vars (dec)

            // set gobject values
        }

        // user defined functions
    }

    public class Xcls_dbmodel : Object
    {
        public Gtk.ListStore el;
        private NewBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_dbmodel(NewBranch _owner )
        {
            _this = _owner;
            _this.dbmodel = this;
            this.el = new Gtk.ListStore( 2, typeof(string),typeof(string) );

            // my vars (dec)

            // set gobject values
        }

        // user defined functions
        public void loadTickets (string project_id , string tid = "") {
        
        
            
            // fixme .. get project id from selection..
            
             RooTicket.singleton().loadTickets(
         			project_id,
         			_this.btn_not_me.el.active ? RooTicket.Who.ANYBODY :  RooTicket.Who.ME,
         			 _this.btn_closed.el.active ? RooTicket.Status.ALL :  RooTicket.Status.ACTIVE
        		 );
                
            _this.ticketsel.loading = true;
        
            this.el.clear();                                    
            Gtk.TreeIter iter;
            var el = this.el;
            
            el.append(out iter);
        
            
            el.set_value(iter, 0, "");
            el.set_value(iter, 1, "-- select a ticket --");
            
            _this.ticketsel.el.set_active_iter(iter);
            var tickets = RooTicket.singleton().tickets;
            foreach(var ticket in tickets) {
            
                el.append(out iter);
                
                el.set_value(iter, 0, ticket.id);
                el.set_value(iter, 1, "#%s %s".printf( ticket.id, ticket.summary));
                
                if (ticket.id == tid) {
        		    _this.ticketsel.el.set_active_iter(iter);
                }
                
            }
            
            _this.ticketsel.loading = false;
             //this.el.set_sort_column_id(0, Gtk.SortType.ASCENDING);          
                                             
        }
    }


    public class Xcls_Button12 : Object
    {
        public Gtk.Button el;
        private NewBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_Button12(NewBranch _owner )
        {
            _this = _owner;
            this.el = new Gtk.Button();

            // my vars (dec)

            // set gobject values
            this.el.expand = false;
            this.el.label = "New Ticket";

            //listeners
            this.el.clicked.connect( () => {
                _this.el.response(-1);
            	Ticket.singleton().show(_this.repo);
            
            });
        }

        // user defined functions
    }

    public class Xcls_Label13 : Object
    {
        public Gtk.Label el;
        private NewBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_Label13(NewBranch _owner )
        {
            _this = _owner;
            this.el = new Gtk.Label( "Use this as branch name" );

            // my vars (dec)

            // set gobject values
            this.el.halign = Gtk.Align.START;
            this.el.justify = Gtk.Justification.RIGHT;
            this.el.xalign = 0.900000f;
        }

        // user defined functions
    }

    public class Xcls_name : Object
    {
        public Gtk.Entry el;
        private NewBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_name(NewBranch _owner )
        {
            _this = _owner;
            _this.name = this;
            this.el = new Gtk.Entry();

            // my vars (dec)

            // set gobject values
            this.el.visible = true;
        }

        // user defined functions
    }

    public class Xcls_createbtn : Object
    {
        public Gtk.Button el;
        private NewBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_createbtn(NewBranch _owner )
        {
            _this = _owner;
            _this.createbtn = this;
            this.el = new Gtk.Button();

            // my vars (dec)

            // set gobject values
            this.el.label = "Create Branch";

            // init method

            {
               this.el.get_style_context().add_class("suggested-action");
            }

            //listeners
            this.el.clicked.connect( () => {
            
            	GLib.debug("fire response = 1");
            	
            	var ticket_id = _this.ticketsel.selectedTicketId();
            	
            	if (ticket_id == "") {
            		_this.ticketsel.el.get_child().get_style_context().add_class("warning");
            		return;
            	}
            	 
            	_this.el.response(1);
            });
        }

        // user defined functions
        public void updateState () {
        
        	var ticket_id = _this.ticketsel.selectedTicketId();
        	
        	if (ticket_id == "") {
        		this.el.set_sensitive(false);
        		return;
        	}
         
        	this.el.set_sensitive(true);
         
        }
    }

    public class Xcls_Box16 : Object
    {
        public Gtk.Box el;
        private NewBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_Box16(NewBranch _owner )
        {
            _this = _owner;
            this.el = new Gtk.Box( Gtk.Orientation.HORIZONTAL, 0 );

            // my vars (dec)

            // set gobject values
            var child_0 = new Xcls_btn_not_me( _this );
            child_0.ref();
            this.el.add (  child_0.el  );
            var child_1 = new Xcls_btn_closed( _this );
            child_1.ref();
            this.el.add (  child_1.el  );
            var child_2 = new Xcls_Label19( _this );
            child_2.ref();
            this.el.add (  child_2.el  );
        }

        // user defined functions
    }
    public class Xcls_btn_not_me : Object
    {
        public Gtk.CheckButton el;
        private NewBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_btn_not_me(NewBranch _owner )
        {
            _this = _owner;
            _this.btn_not_me = this;
            this.el = new Gtk.CheckButton();

            // my vars (dec)

            // set gobject values
            this.el.label = "Show tickets not assigned to me";

            //listeners
            this.el.toggled.connect( () => {
            	var project_id = _this.projectsel.selectedProjectId();
            	_this.dbmodel.loadTickets(project_id);	
            });
        }

        // user defined functions
    }

    public class Xcls_btn_closed : Object
    {
        public Gtk.CheckButton el;
        private NewBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_btn_closed(NewBranch _owner )
        {
            _this = _owner;
            _this.btn_closed = this;
            this.el = new Gtk.CheckButton();

            // my vars (dec)

            // set gobject values
            this.el.label = "Show closed Tickets";

            //listeners
            this.el.toggled.connect( () => {
             	var project_id = _this.projectsel.selectedProjectId();
            	_this.dbmodel.loadTickets(project_id);	
            	 
            });
        }

        // user defined functions
    }

    public class Xcls_Label19 : Object
    {
        public Gtk.Label el;
        private NewBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_Label19(NewBranch _owner )
        {
            _this = _owner;
            this.el = new Gtk.Label( "<a href=\"refresh\">Refresh Ticket list</a>" );

            // my vars (dec)

            // set gobject values
            this.el.halign = Gtk.Align.END;
            this.el.hexpand = true;
            this.el.use_markup = true;

            //listeners
            this.el.activate_link.connect( (uri) => {
            	if (uri == "refresh") {
            		RooProject.reload();
            		var curproj = RooProject.getProjectByRepo(_this.repo);
            		 _this.prmodel.loadProjects(curproj == null ? "": curproj.id);
            
            		_this.dbmodel.loadTickets(curproj == null ? "": curproj.id);		
            	}
            	return true;
            });
        }

        // user defined functions
    }



    public class Xcls_scrolled_window : Object
    {
        public Gtk.ScrolledWindow el;
        private NewBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_scrolled_window(NewBranch _owner )
        {
            _this = _owner;
            _this.scrolled_window = this;
            this.el = new Gtk.ScrolledWindow( null, null );

            // my vars (dec)

            // set gobject values
            this.el.height_request = 500;
            this.el.vexpand = true;
            var child_0 = new Xcls_view( _this );
            child_0.ref();
            this.el.add (  child_0.el  );

            // init method

            {
            	this.el.set_policy(Gtk.PolicyType.AUTOMATIC, Gtk.PolicyType.AUTOMATIC);
            }
        }

        // user defined functions
    }
    public class Xcls_view : Object
    {
        public WebKit.WebView el;
        private NewBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_view(NewBranch _owner )
        {
            _this = _owner;
            _this.view = this;
            this.el = new WebKit.WebView();

            // my vars (dec)

            // set gobject values
        }

        // user defined functions
        public void loadTicket (string tid) {
        	int h,w;
        	_this.el.get_size(out w, out h);
        	
        	if (tid == "") {
        		_this.scrolled_window.el.hide();
        		_this.el.resize(w, 150);
        	} else {
        		_this.scrolled_window.el.show();
        		_this.el.resize(w, 800);
        	}
        	
        	var rs =  RooTicket.singleton();		
        	var uri = new WebKit.URIRequest("https://roojs.com/admin.php/MTrack/View/" + tid);
        	var hd = uri.get_http_headers();
        	var authCode = Base64.encode ("%s:%s".printf(rs.username, rs.password).data);
        	hd.append("Authorization", "Basic %s".printf(authCode));
        	
        	 this.el.load_request(uri);
        }
    }



    public class Xcls_Notebook22 : Object
    {
        public Gtk.Notebook el;
        private NewBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_Notebook22(NewBranch _owner )
        {
            _this = _owner;
            this.el = new Gtk.Notebook();

            // my vars (dec)

            // set gobject values
            this.el.vexpand = true;
            var child_0 = new Xcls_label_select_ticket( _this );
            child_0.ref();
            var child_1 = new Xcls_label_create_ticket( _this );
            child_1.ref();
            var child_2 = new Xcls_label_quick_commit( _this );
            child_2.ref();
        }

        // user defined functions
    }
    public class Xcls_label_select_ticket : Object
    {
        public Gtk.Label el;
        private NewBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_label_select_ticket(NewBranch _owner )
        {
            _this = _owner;
            _this.label_select_ticket = this;
            this.el = new Gtk.Label( "Select Existing Ticket to work on" );

            // my vars (dec)

            // set gobject values
        }

        // user defined functions
    }

    public class Xcls_label_create_ticket : Object
    {
        public Gtk.Label el;
        private NewBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_label_create_ticket(NewBranch _owner )
        {
            _this = _owner;
            _this.label_create_ticket = this;
            this.el = new Gtk.Label( "Create a new Ticket" );

            // my vars (dec)

            // set gobject values
        }

        // user defined functions
    }

    public class Xcls_label_quick_commit : Object
    {
        public Gtk.Label el;
        private NewBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_label_quick_commit(NewBranch _owner )
        {
            _this = _owner;
            _this.label_quick_commit = this;
            this.el = new Gtk.Label( "Quick Commit" );

            // my vars (dec)

            // set gobject values
        }

        // user defined functions
    }


    public class Xcls_Box26 : Object
    {
        public Gtk.Box el;
        private NewBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_Box26(NewBranch _owner )
        {
            _this = _owner;
            this.el = new Gtk.Box( null, 0 );

            // my vars (dec)

            // set gobject values
            this.el.homogeneous = false;
        }

        // user defined functions
    }

}
